<template>
  <v-dialog
    :value="offer"
    @close="close"
    @click:outside="close"
    max-width="500px"
  >
    <v-card v-if="offer">
      <v-toolbar dense color="primary">
        <v-toolbar-title class="white--text">
          Продать токены
        </v-toolbar-title>
        <v-spacer />
        <v-btn @click="close" icon class="white--text"
          ><v-icon>mdi-close</v-icon></v-btn
        >
        <template v-slot:extension v-if="disabled">
          <v-progress-linear indeterminate></v-progress-linear>
        </template>
      </v-toolbar>
      <v-container>
        <v-row>
          <v-col cols="12">
            <v-select
              v-model="bankDetailsData"
              placeholder="Выберите реквизиты"
              :items="bankDetails"
              :item-text="item => `${item.bank} ${item.card}`"
              hide-details
            >
              <template v-slot:append-item>
                <v-btn
                  @click="$router.push({ name: 'BankDetails' })"
                  block
                  text
                >
                  <v-icon>mdi-plus</v-icon> Добавить реквизиты
                </v-btn>
              </template>
            </v-select>
          </v-col>
          <v-col cols="12">
            <v-text-field
              label="Продаете"
              readonly
              :value="`${fromScaledAmount(offer.amount)} LDS`"
              hide-details
            />
          </v-col>
          <v-col cols="12">
            <v-text-field
              label="Получаете"
              readonly
              :value="`${offer.rate.price / 100} ${offer.rate.currency}`"
              hide-details
            />
          </v-col>
          <v-col cols="12">
            <v-alert type="warning">
              Исполнение заявки может занимать до 10 рабочих дней. Будьте
              внимательны при заполнении реквизитов в случае ошибки - ваши
              средства могут быть утеряны навсегда
            </v-alert>
          </v-col>
          <v-col cols="12">
            <v-btn
              @click="sell"
              color="red darken-3"
              class="white--text"
              block
              :disabled="disabled"
            >
              Продать
            </v-btn>
          </v-col>
        </v-row>
      </v-container>
    </v-card>
  </v-dialog>
</template>

<script lang="ts">
import Vue from 'vue';
import Component from 'vue-class-component';
import { Prop } from 'vue-property-decorator';
import {
  BankDetailsResponse,
  OfferResponse,
  ReserveOfferCommand
} from '@/api/ledius-token';
import BankDetailsList from '@/components/bank-details/BankDetailsList.vue';
import { fromScaledAmount } from '@/utils';
import { AuthInfoResponse } from '@/domain/response/auth/info/AuthInfoResponse';

@Component({
  components: {
    BankDetailsList
  }
})
export default class OfferSellDialog extends Vue {
  @Prop({
    required: false,
    default: null,
    validator(value: unknown): boolean {
      return typeof value === 'object' || value === null;
    }
  })
  private readonly offer!: OfferResponse | null;

  @Prop({
    required: true
  })
  private readonly bankDetails!: BankDetailsResponse[];

  @Prop({
    required: true
  })
  private readonly authInfo!: AuthInfoResponse;

  private disabled: boolean = false;

  private bankDetailsData: BankDetailsResponse | null = null;

  private async updated(): Promise<void> {
    this.bankDetailsData = this.bankDetails[0] || null;
  }

  private readonly fromScaledAmount = (amount: string, decimals = 18): string =>
    fromScaledAmount(amount, decimals);

  private async sell(): Promise<void> {
    if (this.bankDetailsData && this.offer && this.authInfo) {
      try {
        this.disabled = true;
        await this.$store.dispatch('exchange/offers/reserve', {
          bankDetails: this.bankDetailsData.id,
          id: this.offer.id,
          reservedBy: this.authInfo.id
        } as ReserveOfferCommand);
        this.close();
      } finally {
        this.disabled = false;
      }
    }
  }

  private close(): void {
    this.$emit('update:offer', null);
  }
}
</script>

<style scoped></style>
